/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package sprite;

import javafx.event.EventHandler;
import javafx.scene.input.*;
import javafx.scene.paint.Color;
import javafx.scene.shape.*;

/**
 *
 * @author km183142m
 */
public class Sun extends Sprite implements EventHandler<MouseEvent> {

    public static final double SUN_RADIUS = 70;

    public static final Color[] colors = {Color.RED, Color.BLUE, Color.GREEN, Color.YELLOW};

    private Circle body;
    private Circle mouth;
    private Color mouthColor;
    
    public Sun(double x, double y) {
        body = new Circle(SUN_RADIUS);
        body.setFill(Color.GOLD);
        mouth = new Circle(SUN_RADIUS / 3);
        mouthColor = colors[(int) (Math.random() * colors.length)];
        mouth.setFill(mouthColor);
        mouth.setTranslateY(SUN_RADIUS / 4);
        getChildren().addAll(body, mouth);
        setTranslateX(x);
        setTranslateY(y);
    }

    public void setRandomMouthColor() {
        mouthColor = colors[(int) (Math.random() * colors.length)];
        mouth.setFill(mouthColor);
    }

    public Color getMouthColor() {
        return mouthColor;
    }

    @Override
    public void update() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void handle(MouseEvent event) {
        double x = event.getX(), y = event.getY();
        double dx = getTranslateX() - x, dy = y - getTranslateY();
        double alpha = 90 - Math.toDegrees(Math.atan(dy / dx));
        if (x > getTranslateX()) {
            alpha -= 180;
        }
        setRotate(alpha);
    }

}
